Added an already running check
[zfs-nexenta/.git] / zfs-replicate
index 128d051a3489903a0e1d84cc67a76ed5ed61e933..8b53d1fb0d4e7a53f4475778cb21c02fc4047251 100755 (executable)
-#/bin/bash
+#!/bin/bash
 
+# Author: Carl Baldwin & Alan Pippin
+# Description: This script replicates a remote zfs filesystem to a local zfs pool.
+#              This script will keep all snapshots in sync, removing the ones
+#              that have been deleted since the last replicate was performed.
+#              This script will only send the new, or missing, snapshots since
+#              the last replicate was performed.
 # Usage: replicate <hostname> <zfs filesystem>
+
+# source our configuration
+config="${0%/*}/zfs-scripts.conf"
+[ -e "${config}.dist" ] && . ${config}.dist
+[ -e "${config}" ] && . ${config}
+
+# command line arg parsing
 remote=$1
 remote_fs=$2
 remote_pool=${2%%/*}
+hostname=`hostname`
 
-# Set this variable to '1' to use the legacy, non-marker, snapshot diff, replicate script logic
-use_legacy_replicate=0
-
-# Set the name of the local pool used to store the backup of the remote
-local_pool=backups
+# Setup our cleanup and exit trap
+cleanup() {
+  if [[ -e "$local_list" ]]; then
+    rm -f $local_list
+  fi
+  if [[ -e "$remote_list" ]]; then
+    rm -f $remote_list
+  fi
+  if [[ -n "$remote" ]]; then
+    ssh $remote ls -d "$lockdir" > /dev/null 2>&1
+    if [[ $? == 0 ]]; then
+      ssh $remote rm -rf "$lockdir"
+    fi
+  fi
+}
+fatal_and_exit() {
+  echo -e 2>&1 "$1"
+  # Destroy the backup markers on the local filesystem if they exist
+  if [[ -n "$current_backup_marker" ]]; then
+    zfs list -t snapshot ${local_pool}/${current_backup_marker} > /dev/null 2>&1
+    if [ $? == 0 ]; then
+      $zfs destroy ${local_pool}/${current_backup_marker}
+    fi
+  fi
+  if [[ -n "$previous_backup_marker" ]]; then
+    zfs list -t snapshot ${local_pool}/${previous_backup_marker} > /dev/null 2>&1 
+    if [ $? == 0 ]; then
+      $zfs destroy ${local_pool}/${previous_backup_marker}
+    fi
+  fi
+  # send email notification
+  if [[ -n "$2" ]]; then
+    echo -e "$1" | $mailx -s "zfs replicate on $hostname failed" "$2"
+  fi
+  # exit
+  exit 1
+}
+trap fatal_and_exit INT
+trap cleanup EXIT
 
 # Make sure we have valid arguments
 if [[ -z "$remote" ]] || [[ -z "$remote_fs" ]]; then
-  echo "Usage: $0 <hostname> <zfs filesystem>"
-  exit 1
+  fatal_and_exit "Usage: $0 <hostname> <zfs filesystem>"
 fi
 
 # Make sure the local pool and local receiving filesystem exist, or print some errors
-if ! zpool list -H "$local_pool" >/dev/null 2>&1; then
-  echo >&2 "-E- The local pool, '$local_pool' doesn't seem to exist."
-  exit 1
+zpool list -H "$local_pool" >/dev/null 2>&1
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- The local pool, '$local_pool' doesn't seem to exist." $mailto
 fi
-if ! zfs list "$local_pool/$remote_pool" >/dev/null 2>&1; then
-  echo >&2 "-E- The local filesystem for the remote pool, '$local_pool/$remote_pool' doesn't seem to exist."
-  echo >&2 "    You will need to create this filesystem before this script can replicate your data."
-  echo >&2 "    You can create this filsystem by executing this command: 'zfs create $local_pool/$remote_pool'"
-  exit 1
+zfs list "$local_pool/$remote_pool" >/dev/null 2>&1
+if [ $? != 0 ]; then
+  echo >&2 "-I- The local filesystem for the remote pool, '$local_pool/$remote_pool' doesn't seem to exist."
+  echo >&2 "    Creating the local filesystem to receive the remote pool into: $local_pool/$remote_pool"
+  $zfs create $local_pool/$remote_pool
+  if [ $? != 0 ]; then
+    fatal_and_exit "-E- remote $zfs create command failed" $mailto
+  fi
 fi
 
 # Obtain the zpool guid for the local pool
 local_pool_guid=`zpool get guid $local_pool 2>&1 | grep $local_pool | awk '{ print $3 }'`
-if ! zpool get guid $local_pool > /dev/null 2>&1; then
-  echo >&2 "-E- Unable to extract the guid for the local pool: $local_pool"
-  exit 1
+zpool get guid $local_pool > /dev/null 2>&1
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- Unable to extract the guid for the local pool: $local_pool" $mailto
 fi
 
 # Turn on shell verbosity
 set -x
 
+# Create the remote lockdir before continuing with the replicate
+# Spinlock on creating the lock
+maxsleeptime=60
+maxattempts=500
+attempts=0
+while true; do
+  ssh $remote mkdir "$lockdir" >/dev/null 2>&1
+  if [ $? != 0 ]; then
+    # Another zfs admin tool is running.
+    # Wait a random amount of time and try again
+    ransleep=$(($RANDOM % $maxsleeptime))
+    sleep $ransleep
+    ((attempts=attempts+1))
+  else 
+    # No other zfs admin tool is running, we can now.
+    break
+  fi
+  if [[ $attempts -gt $maxattempts ]]; then
+    # We've exceeded our maximum while loop count
+    echo "-E- The zfs filesystem has been locked down. Skipping replicate operation."
+    fail_msg=`ssh $remote ls -ld $lockdir 2>&1`
+    fatal_and_exit "zfs-replicate-all unable to obtain zfs admin lock:\n$fail_msg" $mailto
+  fi
+done
+
 # Setup our backup marker names
 current_backup_marker=${remote_fs}@current-backup-${local_pool_guid}
 previous_backup_marker=${remote_fs}@previous-backup-${local_pool_guid}
 
-# The ssh connection doesn't find zfs without this.
-zfs=/usr/sbin/zfs
-
 # List the snapshots on the remote machine.
 remote_list=$(mktemp /tmp/replicate.XXXXXX)
 ssh $remote \
     $zfs list -H -t snapshot |
     grep ^${remote_fs}@ |
     awk '{print$1}' > $remote_list
-if [[ $? != 0 ]]; then
-  echo "-E- remote $zfs list command failed"
-  exit 1
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- remote $zfs list command failed" $mailto
 fi
 
 # List the snapshots on the local machine.
+# Don't list the current backup marker if it exists on the local side.
+# If you do, it can mess up the common finding algorithm below.
 local_list=$(mktemp /tmp/replicate.XXXXXX)
 $zfs list -H -t snapshot |
     grep ^${local_pool}/${remote_fs}@ |
-    awk '{gsub(/^${local_pool}./,"",$1); print$1}' > $local_list
-if [[ $? != 0 ]]; then
-  echo "-E- local $zfs list command failed"
-  exit 1
+    grep -v ^${local_pool}/${current_backup_marker} | 
+    awk "{gsub(/^$local_pool./,\"\",\$1); print\$1}" > $local_list
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- local $zfs list command failed" $mailto
 fi
 
-if [ $use_legacy_replicate == 0 ]; then
-  # Destroy the current backup marker snapshot on the remote system if it exists
-  grep -q ${current_backup_marker} $remote_list
-  if [ $? == 0 ]; then
-    ssh $remote $zfs destroy ${current_backup_marker} 
-    if [[ $? != 0 ]]; then
-      echo "-E- remote $zfs destroy command failed"
-      exit 1
-    fi
-  fi
-  # Create the current backup marker snapshot on the remote system
-  ssh $remote $zfs snapshot ${current_backup_marker}
-  if [[ $? != 0 ]]; then
-    echo "-E- remote $zfs snapshot command failed"
-    exit 1
+# Destroy the current backup marker snapshot on the remote system if it exists
+grep -q ${current_backup_marker} $remote_list
+if [ $? == 0 ]; then
+  ssh $remote $zfs destroy ${current_backup_marker} 
+  if [ $? != 0 ]; then
+    fatal_and_exit "-E- remote $zfs destroy command failed" $mailto
   fi
+fi
 
-  # Check to see if the previous backup marker exists in the remote snapshot list.
-  # Check to see if the previous backup marker exists in the local snapshot list.
-  # If the previous backup markers exists, perform an incremental replicate.
-  # Otherwise, perform a full replicate.
-  grep -q ${previous_backup_marker} $remote_list
-  full=$?
-  grep -q ${previous_backup_marker} $local_list
-  full=$(($full || $?))
+# Create the current backup marker snapshot on the remote system
+ssh $remote $zfs snapshot ${current_backup_marker}
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- remote $zfs snapshot command failed" $mailto
+fi
 
-  if [[ $full == 0 ]]; then
-    ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} | 
-        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
-    if [[ $? != 0 ]]; then
-      echo "-E- remote incremental $zfs send command failed"
-      exit 1
-    fi
-  else
-    ssh $remote $zfs send -R ${current_backup_marker} |
-        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
-    if [[ $? != 0 ]]; then
-      echo "-E- remote full $zfs send command failed"
-      exit 1
-    fi
+# Check to see if the previous backup marker exists in the remote snapshot list.
+# Check to see if the previous backup marker exists in the local snapshot list.
+# If the previous backup markers exists, perform an incremental replicate. Else:
+# 1) check to see if a common snapshot exists, and perform an incremental replicate.
+# 2) if no common snapshot exists, destroy the local filesystem, and perform a full replicate.
+grep -q ${previous_backup_marker} $remote_list
+no_markers=$?
+grep -q ${previous_backup_marker} $local_list
+no_markers=$(($no_markers || $?))
+
+if [ $no_markers == 0 ]; then
+  # We found backup markers, incrementally send the new snaps
+
+  # First, rollback the local pool to the previous backup marker in case the previous
+  # backup was interrupted for some reason. If we don't do this, the zfs send -R command
+  # below may complain about snaps already existing as it tries to resend from the 
+  # previous backup marker again from a previously interrupted replicate.
+  $zfs rollback -r ${local_pool}/${previous_backup_marker} 
+  if [ $? != 0 ]; then
+    fatal_and_exit "-E- remote incremental $zfs rollback command failed" $mailto
   fi
-  # destroy the previous backup markers now that we've replicated past them
-  $zfs destroy ${local_pool}/${previous_backup_marker} > /dev/null 2>&1
-  ssh $remote $zfs destroy ${previous_backup_marker} > /dev/null 2>&1
-
-  # Rename the current backup marker to be the previous backup marker
-  $zfs rename ${local_pool}/${current_backup_marker} ${local_pool}/${previous_backup_marker}
-  if [[ $? != 0 ]]; then
-    echo "-E- local $zfs rename command failed"
-    exit 1
+  # Now it should be safe to send the snaps
+  if [[ $throttle_enable == 1 && -e $throttle ]]; then
+    ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} | 
+        $throttle $throttle_opt | $zfs receive -vF -d ${local_pool}/${remote_pool}
+  else 
+    ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} |
+        $zfs receive -vF -d ${local_pool}/${remote_pool}
   fi
-  ssh $remote $zfs rename ${current_backup_marker} ${previous_backup_marker}
-  if [[ $? != 0 ]]; then
-    echo "-E- remote $zfs rename command failed"
-    exit 1
+  if [ $? != 0 ]; then
+    fatal_and_exit "-E- remote incremental $zfs send command failed" $mailto
   fi
-   
 else
+  # We didn't find any backup markers, next check to see if we have a common snapshot.
+
   # See what the most recent snapshot on the remote end is.
   latest=$(tail -n 1 $remote_list)
 
@@ -136,17 +200,61 @@ else
   echo bogus.local  >> $local_list
   common=$(diff -u $remote_list $local_list | grep '^ ' | tail -n 1)
 
-  if [ -n "$common" ]; then 
-    # We found a common snapshot
-    ssh $remote $zfs send -R -I${common/*@/@} $latest |
-        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+  if [[ -n "$common" ]]; then
+    # We found a common snapshot, incrementally send the new snaps
+    if [[ $throttle_enable == 1 && -e $throttle ]]; then
+      ssh $remote $zfs send -R -I${common/*@/@} ${current_backup_marker} |
+          $throttle $throttle_opt | $zfs receive -vF -d ${local_pool}/${remote_pool}
+    else
+      ssh $remote $zfs send -R -I${common/*@/@} ${current_backup_marker} |
+          $zfs receive -vF -d ${local_pool}/${remote_pool}
+    fi
+    if [ $? != 0 ]; then
+      fatal_and_exit "-E- remote incremental $zfs send command failed" $mailto
+    fi
   else
-    # We did not find a common snapshot, so send the entire filesystem
-    ssh $remote $zfs send -R $latest |
-        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+    # We did not find any markers or a common snapshot
+    # At this point, we'll have to send the entire filesystem
+    # Destroy the local filesystem if it exists before receving the full replicate
+    zfs list ${local_pool}/${remote_fs} > /dev/null 2>&1
+    if [ $? == 0 ]; then
+      if [[ $destroy_local_filesystem_on_full_replicate == 1 ]]; then
+        $zfs destroy -r ${local_pool}/${remote_fs}
+        if [ $? != 0 ]; then
+          fatal_and_exit "-E- remote full $zfs destroy command failed" $mailto
+        fi
+      else
+        echo "-W- We need to destroy a local filesystem before receiving a full stream."
+       echo "    However, since the option is set to prevent this, skipping replicate operation."
+        fatal_and_exit "unable to destroy local filesystem:\n$zfs destroy -r ${local_pool}/${remote_fs} not able to run" $mailto
+      fi
+    fi
+    # Send the full filesystem
+    if [[ $throttle_enable == 1 && -e $throttle ]]; then
+      ssh $remote $zfs send -R ${current_backup_marker} |
+          $throttle $throttle_opt | $zfs receive -vF -d ${local_pool}/${remote_pool}
+    else
+      ssh $remote $zfs send -R ${current_backup_marker} |
+          $zfs receive -vF -d ${local_pool}/${remote_pool}
+    fi
+    if [ $? != 0 ]; then
+      fatal_and_exit "-E- remote full $zfs send command failed" $mailto
+    fi
   fi
 fi
+# destroy the previous backup markers now that we've replicated past them
+# don't check the return codes here because these may not exist, and that is ok
+$zfs destroy ${local_pool}/${previous_backup_marker} > /dev/null 2>&1
+ssh $remote $zfs destroy ${previous_backup_marker} > /dev/null 2>&1
 
-# Remove tmp files
-#rm -f $local_list $remote_list
+# Rename the current backup marker to be the previous backup marker
+$zfs rename ${local_pool}/${current_backup_marker} ${local_pool}/${previous_backup_marker}
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- local $zfs rename command failed" $mailto
+fi
+ssh $remote $zfs rename ${current_backup_marker} ${previous_backup_marker}
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- remote $zfs rename command failed" $mailto
+fi